/* 
 * Tactic is the legal property of its developers, whose names are too numerous 
 * to list here.  Please refer to the COPYRIGHT file distributed with this 
 * source distribution. 
 * 
 * This library is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation; either 
 * version 2.1 of the License, or (at your option) any later version. 
 * 
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 * Lesser General Public License for more details. 
 * 
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA 
 *
 * See README for more informations
 *
 * Force.cpp
 *
 * This class is the difference between the force of the ally group and the ennemy group
 *
 * Date 19/03/06
 *
 */

#include "Force.h"
#include "ForceHigh.h"
#include "ForceMiddle.h"
#include "ForceLow.h"
#include "GroupAI.h"

using namespace std;
	
Force::Force(void){
	name = FORCE;
}

Force::Force(vector<FuzzyValue*> vect){
	name = FORCE;
	this->setVect(vect);
}

Force::Force(ForceHigh* fv1, ForceMiddle* fv2, ForceLow* fv3){
	name = FORCE;
	vector<FuzzyValue*> vect = vector<FuzzyValue*>();
	vect.push_back(fv1);
	vect.push_back(fv2);
	vect.push_back(fv3);
	this->setVect(vect);
}

Force::~Force(void){}

void Force::update(void){
	// à voir
	int forceE = ennemy->getForce();
	int forceA = ally->getForce();
	if(forceE + forceA > 0){
		value = (float)forceA/(float)(forceE + forceA);
	}
	else{
		if(forceE == 0){
			value = infinite;
		}
	}
	value = value * 100;
	notify();
	DebugAI::trace('n', "Ennemy force = " + Converter::floatToString(forceE));
	DebugAI::trace('n', "Ally force = " + Converter::floatToString(forceA));
	DebugAI::trace('n', toString());
	
}

void Force::setEnnemy(GroupEnnemy* ennemy){
	this->ennemy = ennemy;
}

void Force::setAlly(GroupAI* ally){
	this->ally = ally;
}
